#ifndef CURVES_HH
#define CURVES_HH
#include "utils.hh"
class Curve {
public :
  virtual mpz_class Enumerate(vector<int>){};// = 0;
	virtual int GetAGenus(){};// = 0;
	virtual int GetGenus(){};// = 0;
	virtual int DimFamily(vector<int>){};// = 0;
	void SetData(int dim, int deg){
		dim_ = dim;
		deg_ = deg;
	}
	void SetDim(int dim) {
		dim_ = dim;
	}
	void SetDeg(int deg) {
		deg_ = deg;
	}
	int GetDim() {
		return dim_;
	}
	int GetDeg() {
		return deg_;
	}
	virtual bool IsSingular(){
		return GetAGenus()-GetGenus();
	}
	vector<int> Rearrange(vector<int>);
private :
	int dim_;
	int deg_;
	
};

mpz_class CharTriple(Curve* c1, Curve* c2, Curve* c3, int nodeCodim1, int nodeCodim2, vector<int> cs, vector<int> ao1, vector<int> ao2, vector<int> ao3);
mpz_class CharPair(Curve* c1, Curve* c2, int nodeCodim, vector<int> cs, vector<int> ao1, vector<int> ao2);
mpz_class CharPairSplit(Curve* c1, Curve* c2, int nodeCodim, vector<int> cs1, vector<int> cs2);
mpz_class ContractedComponent(Curve* c, int nodeCodim, vector<int> cs, vector<int> ao1, vector<int> ao2);


#endif
