#include "ell.hh"

extern mymap dbr, dbs, dbn, dbc, dbe;
extern map2mymap db2p;
extern vector<int> test,test2;




mpz_class charEll(int dim, int deg, vector<int> cse){
	mpz_class result(0);
 
  int numHP =  cse[1];
  cse[1] =0;

//	initCharEll();  

  vector<int> data;
  data = readVector(cse);
  data.push_back(deg);
 
  if (dbe.find(data) != dbe.end()) 
    return dbe[data] * power(deg,numHP);

  if (cse[0] == 0) {
    dbe[data] = countEll2(dim, deg, cse);
    return dbe[data]*power(deg,numHP);
  }

	vector<int> cst = cse;
	cst[0] = cse[0] -1;
	cst[2]++; 
	result += charEll(dim,deg,cst);
	cst[2]--;
	result += deg*charFixJ(dim,deg,cst)/12;

	int tangency= cse[0]-1;


  vector<int> cs = cse;

  for (int d=1; d <=deg-1; d++) {
    cse[0]= tangency;
    int degen = 0;
    while (degen <= tangency && degen <= dim) {
      vector<int> addons1;
      vector<int> addons2;
			Elliptic el; el.SetData(dim,deg-d);
			Rational r1; r1.SetData(dim,d);
      mpz_class increment = CharPair(&r1,&el,degen,cse,addons1,addons2);
      increment *= d*combinations(degen,tangency)*power(2,degen);
			//if (deg-d == 2)
			//	increment /=2;
      //if (d == deg -d)
       //  increment /= 2;
      result += increment;
      
      degen++;
      cse[0]--;
    }
    
  }
  cse[0] = tangency;
	dbe[data] = result;


	return result * power(deg,numHP);

}


mpz_class countEll1(int dim, int deg, vector<int> cs){
	if (deg <3) return 0;
  int numHP = cs[1];
  cs[1] =0;
  int nonHP = numSP(cs);

  if  (dimModSpaceEll(dim,nonHP,deg) < sum(cs)) {
    return 0;
  }
  if (dimModSpaceEll(dim,nonHP,deg) > sum(cs) ) {
    cout << "incomplete collection in countEll" << endl;
    printdata(cs,deg,dim,0);
    exit(1);
  }
  if (deg == 3 && dim > 2 && cs[dim] > 3)
    return 0;
  
  mpz_class count =0;
  int mu =3;
   

  int i =2;
  while (cs[i] < 2)
    i++;
  int p = i-1;
  cs[i] += -2;

  if (p != 1) {
    mu = 2;
    if (p*2 <=dim) {
      vector<int> css =cs;
      css[2]++;
      css[p*2]++;
			mpz_class inc = charEll(dim,deg,css);
      count += -inc*12;
    }
  }

// count -12D_22
  count += -countD22(dim,deg,cs,1,1,p,p)*12; 
  count += -countD22(dim,deg,cs,1,p,1,p)*12*2; 
	
	//if (cs[3] == 6 && deg == 5)
	//	cout << count << endl;
	

 //count 4D_23


  
  count += countD23(dim,deg,cs,1,1,p,p)*4*2; 
  count += countD23(dim,deg,cs,1,p,1,p)*4*2*2; 
  count += countD23(dim,deg,cs,1,p,p,1)*4*2*2;
  count += countD23(dim,deg,cs,p,p,1,1)*4*2; 
	
	//if (cs[3] == 6 && deg == 5)
	//	cout << count << endl;



// count 2D_24;
  count += countD24(dim,deg,cs,1,1,p,p)*2; 
  count += countD24(dim,deg,cs,1,p,1,p)*2*2*2;
  count += countD24(dim,deg,cs,p,p,1,1)*2;

	//if (cs[3] == 6 && deg == 5)
	//	cout << count << endl;


// count -6D34
  count += -countD34(dim,deg,cs,1,1,p,p)*6*2; 
  count += -countD34(dim,deg,cs,1,p,p,1)*6*2; 

//	if (cs[3] == 6 && deg == 5)
//		cout << count << endl ;


// count -D_03;
  count += -countD03(dim,deg,cs,1,1,p,p)*2;
  count += -countD03(dim,deg,cs,1,p,p,1)*2;

//	if (cs[3] == 6 && deg == 5)
//		cout << count << endl;


//-count D_04;
  count += -countD04(dim,deg,cs,1,1,p,p);

//	if (cs[3] == 6 && deg == 5)
//		cout << count << endl;

 
//count 2D_B;
  count += countDB(dim,deg,cs,1,1,p,p); 
  count += countDB(dim,deg,cs,1,p,1,p)*2;

//	if (cs[3] == 6 && deg  == 5)
//		cout << count << endl;


  if (count % (12*mu) !=0)
    cout << "something wrong in countEll" << count % (12*mu) << endl;
  count /= 12*mu;
  count *= power(deg,numHP);
  return count;
}



mpz_class countEll2(int dim, int deg, vector<int> cs){
	if (deg <3) return 0;
  int numHP = cs[1];
  cs[1] =0;
  int nonHP = numSP(cs);

  if  (dimModSpaceEll(dim,nonHP,deg) < sum(cs)) {
    return 0;
  }
  if (dimModSpaceEll(dim,nonHP,deg) > sum(cs) ) {
    cout << "incomplete collection in countEll" << endl;
    printdata(cs,deg,dim,0);
    exit(1);
  }
  if (deg == 3 && dim > 2 && cs[dim] > 3)
    return 0;
  
  mpz_class count =0;
  int mu =3;
   

  int i =dim;
  while (cs[i] < 2)
    i--;
  int p = i-1;
  cs[i] += -2;

  if (p != 1) {
    mu = 2;
    if (p*2 <=dim) {
      vector<int> css =cs;
      css[2]++;
      css[p*2]++;
			mpz_class inc = charEll(dim,deg,css);
      count += -inc*12;
    }
  }

// count -12D_22
  count += -countD22(dim,deg,cs,1,1,p,p)*12; 
  count += -countD22(dim,deg,cs,1,p,1,p)*12*2; 
	
	//if (cs[3] == 6 && deg == 5)
	//	cout << count << endl;
	

 //count 4D_23


  
  count += countD23(dim,deg,cs,1,1,p,p)*4*2; 
  count += countD23(dim,deg,cs,1,p,1,p)*4*2*2; 
  count += countD23(dim,deg,cs,1,p,p,1)*4*2*2;
  count += countD23(dim,deg,cs,p,p,1,1)*4*2; 
	
	//if (cs[3] == 6 && deg == 5)
	//	cout << count << endl;



// count 2D_24;
  count += countD24(dim,deg,cs,1,1,p,p)*2; 
  count += countD24(dim,deg,cs,1,p,1,p)*2*2*2;
  count += countD24(dim,deg,cs,p,p,1,1)*2;

	//if (cs[3] == 6 && deg == 5)
	//	cout << count << endl;


// count -6D34
  count += -countD34(dim,deg,cs,1,1,p,p)*6*2; 
  count += -countD34(dim,deg,cs,1,p,p,1)*6*2; 

//	if (cs[3] == 6 && deg == 5)
//		cout << count << endl ;


// count -D_03;
  count += -countD03(dim,deg,cs,1,1,p,p)*2;
  count += -countD03(dim,deg,cs,1,p,p,1)*2;

//	if (cs[3] == 6 && deg == 5)
//		cout << count << endl;


//-count D_04;
  count += -countD04(dim,deg,cs,1,1,p,p);

//	if (cs[3] == 6 && deg == 5)
//		cout << count << endl;

 
//count 2D_B;
  count += countDB(dim,deg,cs,1,1,p,p); 
  count += countDB(dim,deg,cs,1,p,1,p)*2;

//	if (cs[3] == 6 && deg  == 5)
//		cout << count << endl;


  if (count % (12*mu) !=0)
    cout << "something wrong in countEll" << count % (12*mu) << endl;
  count /= 12*mu;
  count *= power(deg,numHP);
  return count;
}




mpz_class countD22(int dim,int deg, vector<int> cs,int a1, int a2, int b1, int b2){
	//printVector(cs);  
	mpz_class result =0;
  vector<int> aor(dim+1,0);
  aor[a1] +=1;
  aor[a2] +=1;
	vector<int> aot(dim+1,0);
	aot[b1] +=1;
	aot[b2] +=1;
	vector<int> aoe(dim+1,0);
	for(int d1=0; d1 <= deg;d1++) {
		for(int d2=0; d2 <= deg-d1-3;d2++) {
			if(d1 + d2 > 0) {
				Rational r1; r1.SetData(dim,d1);
				Rational r2; r2.SetData(dim,d2);
				Elliptic el; el.SetData(dim,deg-d1-d2);
				result += CharTriple(&r1,&el,&r2,0,0,cs,aor,aoe,aot);
			}
		}
	}			
  
	return result;
} 

bool repeat(int t1,int t2,int r,int e){
  return ((e > t1) && (e > t2) && (e >r) && (e+1== t2 + r + t1) );
}

mpz_class countD23(int dim,int deg, vector<int> cs,int t1, int t2, int r, int e){

  mpz_class result =0;
  vector<int> aor(dim+1,0);
  vector<int> aot(dim+1,0);
  vector<int> aoe(dim+1,0);
	aor[r] +=1;
	aot[t1] +=1;
	aot[t2] +=1;
  aoe[e] +=1;
	for(int d1=0; d1 <= deg;d1++) {
		for(int d2=0; d2 <= deg-d1-3;d2++) {
			Rational r1; r1.SetData(dim,d1);
			Rational r2; r2.SetData(dim,d2);
			Elliptic el; el.SetData(dim,deg-d1-d2);
			result += CharTriple(&el,&r1,&r2,0,0,cs,aoe,aor,aot);
		//	if (deg == 5 && cs[3] == 6)
		//		cout << result << endl;
		}
	}		
  return result;
   // + 3 components curve
}

mpz_class countD24(int dim, int deg, vector<int> cs, int t1, int t2, int r1, int r2){

  mpz_class result =0;
	vector<int> aot(dim+1,0);
  vector<int> aor(dim+1,0);
  vector<int> aoe(dim+1,0);
  aor[r1] +=1;
  aor[r2] +=1;
	aot[t1] +=1;
	aot[t2] +=1;
	 

	for(int d1=0; d1 <= deg;d1++) {
		for(int d2=0; d2 <= deg-d1-3;d2++) {
			Rational r1; r1.SetData(dim,d1);
			Rational r2; r2.SetData(dim,d2);
			Elliptic el; el.SetData(dim,deg-d1-d2);
			result += CharTriple(&el,&r1,&r2,0,0,cs,aoe,aor,aot);
		}
	}			

  return result;
  // + 3 component curves
}

mpz_class countD34(int dim, int deg, vector<int> cs, int t1, int t2, int t3, int r){
  mpz_class result =0;
  vector<int> aot(dim+1,0);
  vector<int> aoe(dim+1,0);
  aot[t1] +=1;
  aot[t2] +=1;
  aot[t3] +=1;   
	vector<int> aor(dim+1,0);
	aor[r] +=1;

	for(int d1=0; d1 <= deg;d1++) {
		for(int d2=0; d2 <= deg-d1-3;d2++) {
			Rational r1; r1.SetData(dim,d1);
			Rational r2; r2.SetData(dim,d2);
			Elliptic el; el.SetData(dim,deg-d1-d2);
			result += CharTriple(&el,&r1,&r2,0,0,cs,aoe,aor,aot);
		}
	}			

  return result;
	// + 3 component curves

}

mpz_class countD03(int dim, int deg, vector<int> cs, int r1,int r2,int r3, int n){
  mpz_class result =0;
  vector<int> aor(dim+1,0);
  vector<int> aon(dim+1,0);
  aor[r1] +=1;
  aor[r2] +=1;
  aor[r3] +=1;
  aon[n] +=1;
  cs.push_back(0);
  for (int dr =1; dr < deg-2; dr++){
		Rational r1; r1.SetData(dim,dr);	
		Nodal n2; n2.SetData(dim,deg-dr);
    //result += charBoundaryNodal2(dim, dr, deg-dr, cs, 0,aor,aon);
		result += CharPair(&r1,&n2,0,cs,aor,aon);
	}
  return result;
}  

mpz_class countD04(int dim, int deg, vector<int> cs, int r1, int r2, int r3, int r4){
  mpz_class result =0;
  vector<int> aor(dim+1,0);
  vector<int> aon(dim+1,0);
  aor[r1] +=1;
  aor[r2] +=1;
  aor[r3] +=1;
  aor[r4] +=1;
  cs.push_back(0);
  for (int dr =1; dr < deg-2; dr++) {
		Rational r1; r1.SetData(dim,dr);	
		Nodal n2; n2.SetData(dim,deg-dr);
    //result += charBoundaryNodal2(dim, dr, deg-dr, cs, 0,aor,aon);
		result += CharPair(&r1,&n2,0,cs,aor,aon);
	}

  cs[r1] +=1;
  cs[r2] +=1;
  cs[r3] +=1;
  cs[r4] +=1;
  int numHP = cs[1];
  cs[1] =0;
    result += charCusp(dim,deg,cs)*power(deg,numHP)/2;
  return result;
}

mpz_class countDB(int dim, int deg, vector<int> cs, int a1, int a2, int b1, int b2){
  mpz_class result =0;
  vector<int> ao1(dim+1,0);
  vector<int> ao2(dim+1,0);
  ao1[a1] +=1;
  ao1[a2] +=1;
  ao2[b1] +=1;
  ao2[b2] +=1;
  for (int d1=1;d1<deg;d1++)
    result +=charBoundaryTwoJoints(dim,d1,deg-d1,cs,0,0,ao1,ao2);
  return result;

}

int Elliptic::DimFamily(vector<int> cs){
	return (GetDim()+1)*GetDeg() - sum(cs) + numSP(cs);
}

mpz_class Elliptic::Enumerate(vector<int> cs){
	cs = Rearrange(cs);
	return charEll(GetDim(),GetDeg(),cs);
}





