#ifndef ELL_HH
#define ELL_HH
#include "curves.hh"
#include "ellFixJ.hh"
#include "cuspidal.hh"




class Elliptic : public Curve {
public:
	int GetAGenus() { 
		return 1;
	}
	int GetGenus() {
		return 1;
	}
	mpz_class Enumerate(vector<int> cs);
	int DimFamily(vector<int> cs);
//	bool IsSingular(){
//		return true;
//	}
};



mpz_class charEll(int, int, vector<int>);
mpz_class countEll1(int dim, int deg, vector<int> cs);
mpz_class countEll2(int dim, int deg, vector<int> cs);
mpz_class countEll3(int dim, int deg, vector<int> cs);
mpz_class countD22(int dim,int deg, vector<int> cs,int a1, int a2, int b1, int b2);
mpz_class countD23(int dim,int deg, vector<int> cs,int t1, int t2, int r, int e);
mpz_class countD24(int dim, int deg, vector<int> cs, int t1, int t2, int r1, int r2);
mpz_class countD34(int dim, int deg, vector<int> cs, int t1, int t2, int t3, int r);
mpz_class countD03(int dim, int deg, vector<int> cs, int r1,int r2,int r3, int n);
mpz_class countD04(int dim, int deg, vector<int> cs, int r1, int r2, int r3, int r4);
mpz_class countDB(int dim, int deg, vector<int> cs, int a1, int b1, int a2, int b2);
mpz_class countRE(int dim, int dr, int de, vector<int> cs, int nodeCodim, vector<int> aor, vector<int> aoe);
mpz_class countOneJointRE(int dim, int dr, int de, vector<int> csr,vector<int> cse, int nodeCodim);

mpz_class countRandER(int dim, int dr1, int der2, vector<int>cs, int nodeCodim1, int nodeCodim2, vector<int> aor1, vector<int> aor2, vector<int> aoe3);
inline mpz_class countOneJointRandER(int dim,int dr1,int der2,vector<int> csr1,vector<int> cser,int nodeCodim1, int nodeCodim2, vector<int> aor2, vector<int> aoe3);
mpz_class countRandRE(int dim, int dr1, int dre2, vector<int> cs, int nodeCodim1, int nodeCodim2, vector<int> aor1, vector<int> aor2, vector<int> aoe3);
inline mpz_class countOneJointRandRE(int dim,int dr1,int dre2,vector<int> csr1,vector<int> csre,int nodeCodim1, int nodeCodim2, vector<int> aor2, vector<int> aoe3);


#endif
