#ifndef ELLFIXJ_HH
#define ELLFIXJ_HH
#include <iostream>
#include<cstdlib>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <set>
#include <string>
#include <fstream>
#include <map>
#include "rational.hh"
#include "curves.hh"


class Nodal : public Curve {
public:
	int GetAGenus() { 
		return 1;
	}
	int GetGenus() {
		return 0;
	}
	mpz_class Enumerate(vector<int> cs);
	int DimFamily(vector<int> cs);
//	bool IsSingular(){
//		return true;
// }
};


class FixJ : public Curve {
public:
	int GetAGenus() { 
		return 1;
	}
	int GetGenus() {
		return 1;
	}
	mpz_class Enumerate(vector<int> cs);
	int DimFamily(vector<int> cs);
};




mpz_class contractedComponentsNodal(int, int, vector<int>, int, vector<int>, vector<int>);
mpz_class countNodal(int,int,vector<int>);
mpz_class countCusp(int,int,vector<int>);
mpz_class countCusp2(int dim, int deg, vector<int> constraints);
mpz_class cBRSP(int, int, int, vector<int>,int, vector<int>, vector<int>);
mpz_class charNodal(int,int,vector<int>);
mpz_class charOneJointNodal(int, int, int, vector<int>, vector<int>, int);
mpz_class charBoundaryNodal(int, int, int, vector<int>,int, vector<int>, vector<int>);
mpz_class charBoundaryNodal2(int, int, int, vector<int>,int, vector<int>, vector<int>);
mpz_class charBoundaryTwoJoints(int,int,int,vector<int>,int,int,vector<int>,vector<int>);
mpz_class specialChar(int, int, vector<int>, int, int);
mpz_class charTwoJoints(int, int, int, vector<int>, vector<int>, int,int);
mymap classOfLocusOfTwoPoints(int,int, vector<int>);


mpz_class charFixJ(int, int, vector<int>);
mpz_class specialCharBoundary(int, int , int ,vector<int>, int, vector<int>, vector<int>,int, int);
mpz_class intersectionWithE2(int, int, int,vector<int>, int, int);
mpz_class charDoubleCover(int,vector<int>);
mpz_class charOfCubic ();



///////////////////////////////////////////////////////////////

#endif
