#include "rational.hh"

extern mymap dbr, dbs, dbn, dbc, dbe;

mpz_class countRational(int dim, int deg, vector<int> csr){
  mpz_class count(0);

  int nonHP = numSP(csr);
  
  if  (dimModSpace(dim,nonHP,deg) < sum(csr) ) 
        return 0;
  if (dimModSpace(dim,nonHP,deg) > sum(csr) ) {
    cout << "incomplete collection in countRational" << endl;
    printdata(csr,deg,dim,0);
    exit(1);
  }

  
  if (nonHP == 2)
    return 1; 
  
  int i=2;
  while (csr[i] == 0)
    i++;
  int pivot = i;
  csr[i] += -1;
  while (csr[i] ==0 )
    i++;
  int s = i;
  csr[i] += -1;
  while (csr[i] ==0 )
    i++;
  int t = i;
  csr[i] += -1;
  
  vector<int> ao1(dim+1,0);
  vector<int> ao2(dim+1,0);
  ao1[pivot-1] += 1;
  ao1[1] +=1;
  ao2[s] +=1;
  ao2[t] +=1;


  for (int d=1; d<= deg;d++) {
		Rational c1,c2;
		c1.SetData(dim,d);
		c2.SetData(dim,deg-d);
		mpz_class inc = -CharPair(&c1,&c2,0,csr,ao1,ao2);		
		count += inc;
	}
  ao1[1] -=1;
  ao1[t] +=1;
  ao2[1] +=1;
  ao2[t] -=1;
  
  for (int d=0; d<=deg;d++) {
		Rational c1,c2;
		c1.SetData(dim,d);
		c2.SetData(dim,deg-d);
		mpz_class inc = CharPair(&c1,&c2,0,csr,ao1,ao2);
		count += inc;
	}
  
 
  
  return count;
} 

mpz_class charRational(int dim, int deg, vector<int> csr){
  mpz_class result(0);
 
  int numHP =  csr[1];
  csr[1] =0;

  
  vector<int> data;
  data = readVector(csr);
  data.push_back(deg);
 
  if (dbr.find(data) != dbr.end()) 
    return dbr[data] * power(deg,numHP);

  if (csr[0] == 0) {
    dbr[data] = countRational(dim, deg, csr);
    return dbr[data]*power(deg,numHP);
  }

  
  
  csr[0] -= 1;
  csr[2] += 1;
  result += charRational(dim,deg,csr)*(deg-1)*2;
  csr[2] -= 1;
  int tangency= csr[0];

  
  for (int d=1; 2*d <= deg;d++){
    csr[0] = tangency;
    int degen =0;
    while (csr[0] >=0  && degen<= dim) {
 
      
      vector<int> ao1;
      vector<int> ao2;
			Rational r1,r2;
			r1.SetData(dim,d);
			r2.SetData(dim,deg-d);
      mpz_class increment = CharPair(&r1,&r2,degen,csr,ao1, ao2);
    
      increment *=combinations(degen,tangency)*power(2,degen+1)*d*(deg-d);
    
      if (d ==deg-d)
	      increment /=2;
      result += increment;

      degen++;
      csr[0]--;
    }
  }
  if (result % 2*deg != 0) {
    cout << "smt" << endl;
    cout << "deg " << deg << " tangency " << tangency + 1 << endl;
    printVector(csr);
  }
  result /= deg*2;
	dbr[data] = result;

	result *= power(deg,numHP);

  
  return result;
  
}

int Rational::DimFamily(vector<int> cs){
	int dim = GetDim();
	int deg = GetDeg();
	return dimModSpace(dim,numSP(cs),deg) - sum(cs);

}

mpz_class Rational::Enumerate(vector<int> cs){
	cs = Rearrange(cs); 
	return charRational(GetDim(), GetDeg(), cs);
}

