#ifndef UTILS_HH
#define UTILS_HH

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cassert>
#include <gmp.h>
#include <gmpxx.h>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
//#include "/home/dung/Documents/Computational/bigint/BigIntegerLibrary.hh"

#define rep(i,j,n) for (i = j; i < (int)n; i++)
#define BigInteger mpz_class;
#define sign(j) ( (j) % 2 == 0 ? 1 : -1)

using namespace std;

typedef unsigned long long ull;
typedef unsigned long int uli;
typedef unsigned int ui;
typedef map<vector<int>,mpz_class> mymap;
typedef map<vector<int>,mymap> map2mymap;

enum classNames {
  first_hyperplane = 0,
  second_hyperplane,
  exceptional_divisor
};


void combinations(mpz_t, int, int);
mpz_class combinations(int,int);



int dimModSpace(int,int,int);
int dimModSpaceNodal(int,int,int);
int dimModSpaceEll(int,int,int);
void printConstraints(vector<int>);
void printVector(vector<int>);
void printdata(vector<int>,int,int,int);
int numberOfCases(vector<int>);
vector<int> readVector(vector<int>);
int sum(vector<int>);
int codim(vector<int>);
int numSP(vector<int>);
int sumVector(vector<int>);
int power(int, int);
void initiate(mymap &, vector<int>,int);
void printChowCycle(mymap);
mymap readCycleFromString(string);
mymap intersectionProduct(mymap, mymap,int);
mpz_class topMonomial(int,int);
vector<int> reducedForm(vector<int>);
void cleanUp(mymap&,int);
mymap sumOfChowClasses(mymap, mymap,int);
void split(vector<int>, vector<vector<int> >&);


#endif
